<?xml version="1.0"?>
<!-- This file is protected by Copyright. Please refer to the COPYRIGHT file
     distributed with this source distribution.

     This file is part of OpenCPI <http://www.opencpi.org>

     OpenCPI is free software: you can redistribute it and/or modify it under
     the terms of the GNU Lesser General Public License as published by the Free
     Software Foundation, either version 3 of the License, or (at your option)
     any later version.

     OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
     WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
     more details.

     You should have received a copy of the GNU Lesser General Public License
     along with this program. If not, see <http://www.gnu.org/licenses/>. -->
<componentspec>
  <!-- The PRBS bit is the least significant bit. All other bits are 0 -->
  <property name="polynomial_taps" type="uchar" arraylength="6" parameter="true" writable="false" default="31,28"
    description="Taps of PRBS polynomial."/>
  <property name="enable" type="bool" writable="true" default="true" description="When true the PRBS synchroniser is enabled."/>
  <property name="invert_input" type="bool" writable="true" default="false"
    description="When false the LFSR feedback bit is calculated from an XOR of the register values at each of the
      ``polynomial_taps``."/>
  <property name="check_period" type="ushort" writable="true" default="100"
    description="Period over which the component counts errors in order to detect synchronisation loss."/>
  <property name="error_threshold" type="ushort" writable="true" default="40"
    description="Number of errors that can occur in the check_period before the component registers a loss of synchronisation with
      the PRBS."/>
  <!-- LINT EXCEPTION: xml_012: 1: Counter does not require default value -->
  <property name="bits_checked_counter" type="ulonglong" volatile="true" writable="false"
    description="Counts the number of bits that have been checked for errors."/>
  <!-- LINT EXCEPTION: xml_012: 1: Counter does not require default value -->
  <property name="error_counter" type="ulonglong" volatile="true" writable="false"
    description="Counts the number of errors detected."/>
  <!-- LINT EXCEPTION: xml_012: 1: Counter does not require default value -->
  <property name="bits_received_counter" type="ulonglong" volatile="true" writable="false"
    description="Counts the total number of bits received by the component, regardless of synchronisation state."/>
  <!-- LINT EXCEPTION: xml_012: 1: Counter does not require default value -->
  <property name="sync_loss_counter" type="ulonglong" volatile="true" writable="false"
    description="Counts the number of times synchronisation with the PRBS has been lost."/>
  <property name="counter_update" type="bool" writable="true" default="true"
    description="When true the volatile counter properties will update continuously. Setting low pauses updating the properties so
      they can be read via the ACI as a group."/>
  <port name="input" producer="false" protocol="bool_timed_sample-prot"/>
  <port name="output" producer="true" optional="true" protocol="char_timed_sample-prot"/>
</componentspec>
